"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CardFieldBase = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactNative = require("react-native");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
class CardFieldBase extends _react.default.Component {
  state = {
    __text__: '',
    __enabled__: true,
    __max_length__: this._maxLength()
  };
  _inputRef = /*#__PURE__*/_react.default.createRef();
  _setEnable = value => {
    this.setState({
      __enabled__: value
    });
  };
  _setText = text => {
    this.setState({
      __text__: text
    });
  };
  _getText = () => {
    return this.state.__text__;
  };
  _setMaxLength = value => {
    this.setState({
      __max_length__: value
    });
  };
  _isSecure() {
    return false;
  }
  _selfName() {
    throw new Error('not implemented');
  }
  _maxLength() {
    throw new Error('not implemented');
  }
  focus() {
    var _this$_inputRef$curre;
    (_this$_inputRef$curre = this._inputRef.current) === null || _this$_inputRef$curre === void 0 ? void 0 : _this$_inputRef$curre.focus();
  }
  render() {
    return /*#__PURE__*/_react.default.createElement(_reactNative.TextInput, _extends({
      ref: this._inputRef
    }, this.props, {
      maxLength: this.state.__max_length__,
      secureTextEntry: this._isSecure(),
      multiline: false,
      editable: this.state.__enabled__,
      keyboardType: 'numeric',
      value: this.state.__text__,
      onChangeText: text => {
        if (this.__onChangeText__) {
          this.__onChangeText__(text);
        }
        this.setState({
          __text__: text
        });
      }
    }));
  }
}
exports.CardFieldBase = CardFieldBase;
//# sourceMappingURL=CardFieldBase.js.map