"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Order = void 0;
var _req = require("./req");
var _Verification = require("./Verification");
class Order {
  _arguments = {};
  constructor() {
    let amount = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _req.req)('amount');
    let currency = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _req.req)('currency');
    let orderId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : (0, _req.req)('orderId');
    let description = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : (0, _req.req)('description');
    let email = arguments.length > 4 ? arguments[4] : undefined;
    this.amount = amount;
    if (typeof currency === 'string') {
      this.currency = currency;
    } else {
      this.currency = currency.code;
    }
    this.orderId = orderId;
    this.description = description;
    this.email = email;
    this.setPreAuth(false);
    this.setRequiredRecToken(false);
    this.setVerificationType(_Verification.Verification.AMOUNT);
    this.setDelayed(false);
  }
  setProductId(productId) {
    this._productId = productId;
  }
  setPaymentSystems(paymentSystems) {
    this._paymentSystems = paymentSystems;
  }
  setDefaultPaymentSystem(defaultPaymentSystem) {
    this._defaultPaymentSystem = defaultPaymentSystem;
  }
  setLifeTime(lifeTime) {
    this._lifeTime = lifeTime;
  }
  setMerchantData(merchantData) {
    this._merchantData = merchantData;
  }
  setVersion(version) {
    this._version = version;
  }
  setServerCallbackUrl(serverCallbackUrl) {
    this._serverCallbackUrl = serverCallbackUrl;
  }
  setLang(lang) {
    this._lang = lang;
  }
  setPreAuth(preAuth) {
    this._preAuth = preAuth;
  }
  setRequiredRecToken(requiredRecToken) {
    this._requiredRecToken = requiredRecToken;
  }
  setVerification(verification) {
    this._verification = verification;
  }
  setVerificationType(verificationType) {
    this._verificationType = verificationType;
  }
  setRecToken(recToken) {
    this._recToken = recToken;
  }
  setDelayed(delayed) {
    this._delayed = delayed;
  }
  addArgument(name, value) {
    this._arguments[name] = value;
  }
}
exports.Order = Order;
//# sourceMappingURL=Order.js.map