"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Receipt = void 0;
class Receipt {
  constructor(maskedCard, cardBin, amount, paymentId, currency, status, transactionType, senderCellPhone, senderAccount, cardType, rrn, approvalCode, responseCode, productId, recToken, recTokenLifeTime, reversalAmount, settlementAmount, settlementCurrency, settlementDate, eci, fee, actualAmount, actualCurrency, paymentSystem, verificationStatus, signature, email, responseUrl) {
    this.maskedCard = maskedCard;
    this.cardBin = cardBin;
    this.amount = amount;
    this.paymentId = paymentId;
    this.currency = currency;
    this.status = status;
    this.transactionType = transactionType;
    this.senderCellPhone = senderCellPhone;
    this.senderAccount = senderAccount;
    this.cardType = cardType;
    this.rrn = rrn;
    this.approvalCode = approvalCode;
    this.responseCode = responseCode;
    this.productId = productId;
    this.recToken = recToken;
    this.recTokenLifeTime = recTokenLifeTime;
    this.reversalAmount = reversalAmount;
    this.settlementAmount = settlementAmount;
    this.settlementCurrency = settlementCurrency;
    this.settlementDate = settlementDate;
    this.eci = eci;
    this.fee = fee;
    this.actualAmount = actualAmount;
    this.actualCurrency = actualCurrency;
    this.paymentSystem = paymentSystem;
    this.verificationStatus = verificationStatus;
    this.signature = signature;
    this.email = email;
    this.responseUrl = responseUrl;
  }
  static __easyDateParser__(str) {
    //expected 05.01.2021 01:31:04
    //why should we use own parser instead of import moment or ... ?
    //because we are library and we:
    //1. should be as tiny as possible
    //2. our clients/developers may use different moment/... versions.
    try {
      if (!str || str.length === 0) {
        return undefined;
      }
      const [date, time] = str.split(' ');
      const [days, months, years] = date.split('.');
      const [hours, minutes, seconds] = time.split(':');
      return new Date(Number(years), Number(months) - 1, Number(days), Number(hours), Number(minutes), Number(seconds), 0);
    } catch (e) {
      return undefined;
    }
  }
  static __fromOrderData__(orderData, responseUrl) {
    let receipt = new Receipt(orderData.masked_card, orderData.card_bin, Number(orderData.amount), orderData.payment_id, orderData.currency, orderData.order_status, orderData.tran_type, orderData.sender_cell_phone, orderData.sender_account, orderData.card_type, orderData.rrn, orderData.approval_code, orderData.response_code, orderData.product_id, orderData.rectoken, this.__easyDateParser__(orderData.rectoken_lifetime), orderData.reversal_amount, orderData.settlement_amount, orderData.settlement_currency, this.__easyDateParser__(orderData.settlement_date), orderData.eci, orderData.fee, orderData.actual_amount, orderData.actual_currency, orderData.payment_system, orderData.verification_status, orderData.signature, orderData.email, responseUrl);
    receipt.dumpFields = () => {
      return orderData;
    };
    return receipt;
  }
}
exports.Receipt = Receipt;
//# sourceMappingURL=Receipt.js.map