import React from 'react';
import { View, Text, StyleSheet } from 'react-native';
import { CardLayout } from './CardLayout';
import { CardFieldNumber } from './CardFieldNumber';
import { CardFieldExpMm } from './CardFieldExpMm';
import { CardFieldExpYy } from './CardFieldExpYy';
import { CardFieldCvv } from './CardFieldCvv';
export class CardInput extends React.Component {
  _cardLayoutRef = /*#__PURE__*/React.createRef();
  _cardFieldNumberRef = /*#__PURE__*/React.createRef();
  _cardFieldExpMmRef = /*#__PURE__*/React.createRef();
  _cardFieldExpYyRef = /*#__PURE__*/React.createRef();
  _cardFieldCvvRef = /*#__PURE__*/React.createRef();
  getCard = () => {
    var _this$_cardLayoutRef$;
    return ((_this$_cardLayoutRef$ = this._cardLayoutRef.current) === null || _this$_cardLayoutRef$ === void 0 ? void 0 : _this$_cardLayoutRef$.getCard()) ?? null;
  };
  showCard = card => {
    var _this$_cardLayoutRef$2;
    (_this$_cardLayoutRef$2 = this._cardLayoutRef.current) === null || _this$_cardLayoutRef$2 === void 0 ? void 0 : _this$_cardLayoutRef$2.showCard(card);
  };
  test = () => {
    var _this$_cardLayoutRef$3;
    (_this$_cardLayoutRef$3 = this._cardLayoutRef.current) === null || _this$_cardLayoutRef$3 === void 0 ? void 0 : _this$_cardLayoutRef$3.test();
  };
  focus = () => {
    var _this$_cardFieldNumbe;
    (_this$_cardFieldNumbe = this._cardFieldNumberRef.current) === null || _this$_cardFieldNumbe === void 0 ? void 0 : _this$_cardFieldNumbe.focus();
  };
  _onSubmitCardFieldNumber = () => {
    var _this$_cardFieldExpMm;
    (_this$_cardFieldExpMm = this._cardFieldExpMmRef.current) === null || _this$_cardFieldExpMm === void 0 ? void 0 : _this$_cardFieldExpMm.focus();
  };
  _onSubmitCardFieldExpMm = () => {
    var _this$_cardFieldExpYy;
    (_this$_cardFieldExpYy = this._cardFieldExpYyRef.current) === null || _this$_cardFieldExpYy === void 0 ? void 0 : _this$_cardFieldExpYy.focus();
  };
  _onSubmitCardFieldExpYy = () => {
    var _this$_cardFieldCvvRe;
    (_this$_cardFieldCvvRe = this._cardFieldCvvRef.current) === null || _this$_cardFieldCvvRe === void 0 ? void 0 : _this$_cardFieldCvvRe.focus();
  };
  _onSubmitCardFieldCvv = () => {
    var _this$props$onComplet, _this$props;
    (_this$props$onComplet = (_this$props = this.props).onCompletion) === null || _this$props$onComplet === void 0 ? void 0 : _this$props$onComplet.call(_this$props, this);
  };
  render() {
    return /*#__PURE__*/React.createElement(CardLayout, {
      ref: this._cardLayoutRef,
      inputNumber: this._inputNumberProvider,
      inputExpMm: this._inputExpMmProvider,
      inputExpYy: this._inputExpYyProvider,
      inputCvv: this._inputCvvProvider
    }, /*#__PURE__*/React.createElement(Text, {
      style: this.props.textStyle,
      onPress: this.props.debug ? this.test : undefined
    }, this.props.labelCardNumber || 'Card Number:'), /*#__PURE__*/React.createElement(CardFieldNumber, {
      ref: this._cardFieldNumberRef,
      placeholder: this.props.placeholderCardNumber,
      onSubmitEditing: this._onSubmitCardFieldNumber,
      style: this.props.textInputStyle
    }), /*#__PURE__*/React.createElement(Text, {
      style: this.props.textStyle
    }, this.props.labelExpirity || 'Expiry:'), /*#__PURE__*/React.createElement(View, {
      style: styles.row
    }, /*#__PURE__*/React.createElement(CardFieldExpMm, {
      ref: this._cardFieldExpMmRef,
      placeholder: this.props.placeholderMM || 'MM',
      onSubmitEditing: this._onSubmitCardFieldExpMm,
      style: [styles.flex1, this.props.textInputStyle]
    }), /*#__PURE__*/React.createElement(CardFieldExpYy, {
      ref: this._cardFieldExpYyRef,
      placeholder: this.props.placeholderYY || 'YY',
      onSubmitEditing: this._onSubmitCardFieldExpYy,
      style: [styles.flex1, this.props.textInputStyle]
    })), /*#__PURE__*/React.createElement(Text, {
      style: this.props.textStyle
    }, this.props.labelCVV || 'CVV:'), /*#__PURE__*/React.createElement(CardFieldCvv, {
      ref: this._cardFieldCvvRef,
      placeholder: this.props.placeholderCVV,
      onSubmitEditing: this._onSubmitCardFieldCvv,
      style: this.props.textInputStyle
    }));
  }
  _inputNumberProvider = () => {
    return this._cardFieldNumberRef.current;
  };
  _inputExpMmProvider = () => {
    return this._cardFieldExpMmRef.current;
  };
  _inputExpYyProvider = () => {
    return this._cardFieldExpYyRef.current;
  };
  _inputCvvProvider = () => {
    return this._cardFieldCvvRef.current;
  };
}
const styles = StyleSheet.create({
  row: {
    flexDirection: 'row'
  },
  flex1: {
    flex: 1
  }
});
//# sourceMappingURL=CardInput.js.map