import { Card, Order, Receipt } from './models';
import { CloudipspWebviewProvider } from './CloudipspWebview';
export declare class Cloudipsp {
    private readonly __merchantId__;
    private readonly __cloudipspView__;
    private readonly __baseUrl__;
    private readonly __callbackUrl__;
    constructor(merchantId?: number, cloudipspView?: CloudipspWebviewProvider);
    static supportsApplePay(): Promise<boolean>;
    static supportsGooglePay(): Promise<boolean>;
    pay(card?: Card, order?: Order): Promise<Receipt>;
    payToken(card?: Card, token?: string): Promise<Receipt>;
    static __assertApplePay__(): Promise<never> | undefined;
    applePayToken(token?: string): Promise<Receipt>;
    applePay(order?: Order): Promise<Receipt>;
    static __assertGooglePay__(): Promise<never> | undefined;
    googlePayToken(token?: string): Promise<Receipt>;
    googlePay(order?: Order): Promise<Receipt>;
    private __getPaymentConfig__;
    private __getToken__;
    private __checkout__;
    private __checkoutApplePay__;
    private __checkoutGooglePay__;
    private __payContinue__;
    private __url3ds__;
    private __getCallbackUrl__;
    private __order__;
    private __apiCall__;
    private __handleResponseError__;
    private __callJson__;
}
//# sourceMappingURL=Cloudipsp.d.ts.map