import { Currency } from './Currency';
import { Lang } from './Lang';
import { Verification } from './Verification';
export declare class Order {
    amount: number;
    currency: string;
    orderId: string;
    description: string;
    email: string;
    private readonly _arguments;
    private _productId?;
    private _paymentSystems?;
    private _defaultPaymentSystem?;
    private _lifeTime?;
    private _merchantData?;
    private _version?;
    private _serverCallbackUrl?;
    private _lang?;
    private _preAuth?;
    private _requiredRecToken?;
    private _verification?;
    private _verificationType?;
    private _recToken?;
    private _delayed?;
    constructor(amount: number | undefined, currency: string | Currency | undefined, orderId: string | undefined, description: string | undefined, email: string);
    setProductId(productId: string): void;
    setPaymentSystems(paymentSystems: string): void;
    setDefaultPaymentSystem(defaultPaymentSystem: string): void;
    setLifeTime(lifeTime: number): void;
    setMerchantData(merchantData: string): void;
    setVersion(version: string): void;
    setServerCallbackUrl(serverCallbackUrl: string): void;
    setLang(lang: Lang): void;
    setPreAuth(preAuth: boolean): void;
    setRequiredRecToken(requiredRecToken: boolean): void;
    setVerification(verification: boolean): void;
    setVerificationType(verificationType: Verification): void;
    setRecToken(recToken: string): void;
    setDelayed(delayed: boolean): void;
    addArgument(name: string, value: string): void;
}
export interface OrderPrivate {
    readonly _arguments: {
        [key: string]: string;
    };
    readonly _productId?: string;
    readonly _paymentSystems?: string;
    readonly _defaultPaymentSystem?: string;
    readonly _lifeTime?: number;
    readonly _merchantData?: string;
    readonly _version?: string;
    readonly _serverCallbackUrl?: string;
    readonly _lang?: Lang;
    readonly _preAuth?: boolean;
    readonly _requiredRecToken?: boolean;
    readonly _verification?: boolean;
    readonly _verificationType?: Verification;
    readonly _recToken?: string;
    readonly _delayed?: boolean;
}
//# sourceMappingURL=Order.d.ts.map